
CREATE TABLE ALS_AUTHORS ( 
  ID                   NUMBER (10)   NOT NULL, 
  FIRST_NAME           VARCHAR2 (30), 
  LAST_NAME            VARCHAR2 (40), 
  INITIALS             VARCHAR2 (15), 
  COUNTRY_OF_BIRTH     VARCHAR2 (2), 
  COUNTRY_OF_LIVING    VARCHAR2 (2), 
  LOCATION_IN_COUNTRY  VARCHAR2 (50), 
  BIOGRAPHY            VARCHAR2 (2000), 
  CONSTRAINT ATR_PK
  PRIMARY KEY ( ID ) ) ; 

COMMENT ON COLUMN ALS_AUTHORS.BIOGRAPHY IS 'Some details on the author like "He has been a J2EE Architect since 1997"';
COMMENT ON COLUMN ALS_AUTHORS.LOCATION_IN_COUNTRY IS 'Indicate city or state within country.';

CREATE TABLE ALS_AUTHORSHIPS ( 
  ID                NUMBER (10)   NOT NULL, 
  CONTRIBUTOR_TYPE  NUMBER (1), 
  BOK_ID            NUMBER (10)   NOT NULL, 
  ATR_ID            NUMBER (10)   NOT NULL, 
  CONSTRAINT ATP_PK
  PRIMARY KEY ( ID ) ) ; 

COMMENT ON COLUMN ALS_AUTHORSHIPS.CONTRIBUTOR_TYPE IS 'What kind of contribution has the author made to this book?';

CREATE TABLE ALS_BOOKS ( 
  ID               NUMBER (10)   NOT NULL, 
  COMPLEXITY       NUMBER (1), 
  ISBN             VARCHAR2 (30), 
  WEIGHT           NUMBER (4), 
  PUBLISH_MONTH    NUMBER (2), 
  FORMAT           VARCHAR2 (1), 
  TITLE            VARCHAR2 (100)  NOT NULL, 
  PUBLISH_YEAR     NUMBER (4), 
  EDITION          VARCHAR2 (50), 
  NUMBER_OF_PAGES  NUMBER (4), 
  LANGUAGE         VARCHAR2 (2), 
  BOK_SIZE         VARCHAR2 (20), 
  LEVEL_OF_DETAIL  NUMBER (1), 
  KEYWORDS         VARCHAR2 (200), 
  PBR_ID           NUMBER (10)   , 
  BOK_ID           NUMBER (10), 
  Thumbnail        blob,
  CONSTRAINT BOK_PK
  PRIMARY KEY ( ID ) ) ; 

COMMENT ON COLUMN ALS_BOOKS.BOK_SIZE IS 'Physical size (cm x cm x cm) of the book';
COMMENT ON COLUMN ALS_BOOKS.EDITION IS 'Indication of the edition (e.g  first edition, fourth edition)';
COMMENT ON COLUMN ALS_BOOKS.KEYWORDS IS 'Which keywords are logically associated with the book?';
COMMENT ON COLUMN ALS_BOOKS.LANGUAGE IS 'What (natural) langage is the book written in';


ALTER TABLE ALS_AUTHORSHIPS ADD  CONSTRAINT ATP_ATR_FK
 FOREIGN KEY (ATR_ID) 
  REFERENCES ALS_AUTHORS (ID) ON DELETE CASCADE DISABLE ;

ALTER TABLE ALS_AUTHORSHIPS ADD  CONSTRAINT ATP_BOK_FK
 FOREIGN KEY (BOK_ID) 
  REFERENCES ALS_BOOKS (ID) ON DELETE CASCADE DISABLE ;

