package nl.amis.als.ejb30;

import java.io.Serializable;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.ManyToMany;
import javax.persistence.JoinTable;
import javax.persistence.JoinColumn;
import javax.persistence.CascadeType;


@Entity
@Table(name="ALS_BOOKS")
public class Book implements Serializable {


    private Long id;

    private String isbn;

    private Long publishMonth;

    private Long publishYear;

    private String title;

    private Collection<Author> authors;

    public Book() {
    }

    public Book(Long id, String title) {
        this.id = id;
        this.title = title;
    }

    @ManyToMany(cascade=CascadeType.ALL)
    @JoinTable(table = @Table(name = "als_authorships"), joinColumns = {
           @JoinColumn(name = "bok_id")
       }, inverseJoinColumns = {
           @JoinColumn(name = "atr_id")
       })
    public Collection<Author> getAuthors() {
        return this.authors;
    }
    
    public void setAuthors(Collection<Author> authors) {
        this.authors = authors;
    }
    
    @Id
    @Column(name="ID", nullable=false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Column(name="ISBN")
    public String getIsbn() {
        return isbn;
    }

    public void setIsbn(String isbn) {
        this.isbn = isbn;
    }

    @Column(name="PUBLISH_MONTH")
    public Long getPublishMonth() {
        return publishMonth;
    }

    public void setPublishMonth(Long publishMonth) {
        this.publishMonth = publishMonth;
    }

    @Column(name="PUBLISH_YEAR")
    public Long getPublishYear() {
        return publishYear;
    }

    public void setPublishYear(Long publishYear) {
        this.publishYear = publishYear;
    }

    @Column(name="TITLE", nullable=false)
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

}
