package nl.amis.als.ejb30;

import java.util.Collection;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import nl.amis.ejb30.hrm.Employee;

public class LibraryService {
    public LibraryService() {

        EntityManagerFactory emf =
            Persistence.createEntityManagerFactory("pu2");
        // create EntityManager
        EntityManager em = emf.createEntityManager();
        this.setEntityManager(em);
    }

    private EntityManager _entityManager;

    public EntityManager getEntityManager() {
        return _entityManager;
    }

    public void setEntityManager(EntityManager entityManager) {
        _entityManager = entityManager;
    }

    public List<Book> findAllBook()  {
        return getEntityManager().createQuery("select object(o) from Book o").getResultList();
    }

    public static void main(String[] args) {
       LibraryService libraryService = new LibraryService();
        Collection<Book> books = libraryService.findAllBook();
        for (Book b : books) { 
          System.out.println(b.getTitle());
          for (Author a: b.getAuthors()) {
              System.out.println(" - "+a.getFirstName()+" "+a.getLastName());
          }
        }        
 
        Collection<Author> authors = libraryService.getEntityManager().createQuery("select object(o) from Author o").getResultList();;
        Author husted = null;
        for (Author a : authors) { 
           if ("husted".equalsIgnoreCase(a.getLastName())) {husted = a;}
        }      
        Book jsf = libraryService.getEntityManager().find(Book.class, new Long(22));
        System.out.println(jsf.getTitle());
        jsf.getAuthors().add(husted);

        EntityTransaction tx = libraryService.getEntityManager().getTransaction();
        tx.begin();
        libraryService.getEntityManager().merge(jsf);
        tx.commit();
        tx.begin();
        jsf.getAuthors().remove(husted);
        libraryService.getEntityManager().merge(jsf);
        tx.commit();

        
    }

}
